var DASHBOARD = {};

DASHBOARD.pickupItems = [
    {id: 'newReport', href: "javascript:DASHBOARD.goPickup('newReport');", count: 0, enabled: true, img: {src: '../common/img/dahboard_icon_new.svg'}, msg: 'newRegistrationTitle', defaultMessage:'New report'},
    {id: 'continousWork', href: "javascript:DASHBOARD.goPickup('continousWork');", count: 0, enabled: true, img: {src: '../common/img/dahboard_icon_proccess.svg'}, msg: 'continousWorkTitle' , defaultMessage:'Continuous Work'},
    {id: 'reportWarning', href: "javascript:DASHBOARD.goPickup('reportWarning');", count: 0, enabled: true, img: {src: '../common/img/dahboard_icon_alert.svg'}, msg: 'reportWarningTitle' , defaultMessage:'Warning report'},
];
DASHBOARD.communicationItems = [
    {id: 'messageList', href: "javascript:DASHBOARD.goMessageList();", count: 0, enabled: true, img: {src: '../common/img/dahboard_icon_message_list.svg'}, msg: 'messageListTitle' , defaultMessage:'Message list'},
    {id: 'sendMessage', href: "javascript:DASHBOARD.goSendMessage();", count: 0, enabled: true, img: {src: '../common/img/dahboard_icon_send_message.svg'}, msg: 'sendMessageTitle' , defaultMessage:'Message'},
    {id: 'distanceSupport', href: "javascript:DASHBOARD.goDistanceSupport();", count: 0, enabled: true, img: {src: '../common/img/dahboard_icon_remote.svg'}, msg: 'distanceSupportTitle' , defaultMessage:'Distance Support'},
    {id: 'chat', href: "javascript:DASHBOARD.goChat();", count: 0, enabled: true, img: {src: '../common/img/dahboard_icon_chat.svg'}, msg: 'chatTitle' , defaultMessage:'Chat'},
];


DASHBOARD.defaultDashboard = {
    newReport: 12,
    continousWork: 100,
    reportWarning: 13,
    pushMesage: 7,
}

DASHBOARD.baseApiUrl = CONSTANT.URL.CMS.BASE + ClientData.userInfo_accountPath() + CONSTANT.URL.CMS.API.BASE + 'topScreen/';
DASHBOARD.getDataApiUrl = DashboardSetting.baseApiUrl + 'getAllData';

// Call api get data 

DASHBOARD.getDashboardData = function (callback) {
    let param = {
        sid: COMMON.getSid(),
    };
    COMMON.cmsAjax(DASHBOARD.getDataApiUrl, param, false, function (json) {
        if (callback) {
            callback(json);
        }
    }, function() {
        console.log('DASHBOARD.getData error');
        if (callback) {
            callback(DASHBOARD.defaultDashboard);
        }
    });
};


//CHK_Dashboard.pickupItemsに設定した情報をhtmlに表示する
DASHBOARD.initPickups = function() {
    $("#pickupItems").empty();
    DASHBOARD.pickupItems.forEach(function(item) {
        if (item.enabled == true  ) {
            var html = DASHBOARD.initHtmlItem(item);
            $("#pickupItems").append(html);
        }
    });
    //pickup empty
    if ($("#pickupItems").children().length > 0) {
        $("#pickupHeader").removeClass('d-none');
    } else {
        $("#pickupHeader").addClass('d-none');
    }
}

//CHK_Dashboard.communicationItemsに設定した情報をhtmlに表示する
DASHBOARD.initCommunications = function() {
    $("#communicationItems").empty();
    DASHBOARD.communicationItems.forEach(function(item) {
        if (item.enabled == true) {
            var html = DASHBOARD.initHtmlItem(item);
            $("#communicationItems").append(html);
        }
    });
}

//設定されている情報からhtmlを表示する
DASHBOARD.initHtmlItem = function(item) {
    var countText = '' + item.count;
    if (item.count >= 100) {
        countText = '99+';
    }
    var countDClass = '';
    var countSpan = ''
    if (typeof item.count != 'undefined' && item.count > 0) {
        countDClass = ' ';
        countSpan = '<span class="fs-8 circle-tag-danger' + countDClass + '">' + countText + '</span>';
    }
    var html = $('<li class="card mb-2 position-relative" id="' + item.id + '">'
                + '<a href="' + item.href + '" class="d-block text-dark text-decoration-none mb-1 p-3 text-center">'
                + '<div class="bg-lightblue p-2 d-inline-block rounded-circle mb-3">'
                + '<img src="' + item.img.src + '" alt="' +  DASHBOARD.getMsg(item.msg, item.defaultMessage) +'" class="img-fluid"> </div>'
                + '<div class="fs-10 multi-lang" data-msg="' + item.msg + '">' + DASHBOARD.getMsg(item.msg , item.defaultMessage) + '</div>'
                + countSpan
                + '</a>'
                + '</li>');
    return html;
}

//ダッシュボード画面の初期表示
DASHBOARD.init = function() {
    DashboardSetting.getSettingData(function (settings) {
        DASHBOARD.getDashboardData(function (dataDashboard) {
            DASHBOARD.updateDataPickups(settings, dataDashboard);
            DASHBOARD.initPickups();
            DASHBOARD.updateDataCommunications(dataDashboard);
            DASHBOARD.initCommunications();
        });
    });  
}

//変数として設定しているガジェットに初期表示で取得したデータを設定
DASHBOARD.updateDataPickups = function(settings, dataDashboard) {
    DASHBOARD.pickupItems.forEach(function(item) {
        let enabled = settings[item.id];
        if (enabled == true || enabled == false) {
            item.enabled = enabled;
        }
        item.count = 0;
        if (dataDashboard[item.id]) {
            item.count = dataDashboard[item.id];
        }
    });
}

//変数として設定しているコミュニケーションに初期表示で取得したデータを設定
DASHBOARD.updateDataCommunications = function(dataDashboard) {
    DASHBOARD.communicationItems.forEach(function(item) {
        if (item.id == 'messageList') {
            item.count = 0;
            if (dataDashboard['pushMesage']) {
                item.count = dataDashboard['pushMesage'];
            } 
        } 
        // else if (item.id == 'chat') {
        //     item.enabled = CHK.isChat;
        // }
    });
}

//ガジェット画面に移動
DASHBOARD.goPickup = function(pickupId) {
    CHK.goUrlWithCurrentParams('pickup.html', {pickupActive: pickupId});
}

//コミュニケーション画面に移動
DASHBOARD.goMessageList = function() {
    CHK.goUrlWithCurrentParams('message-list.html', {});
}

//コミュニケーション画面に移動
DASHBOARD.getMsg = function(message, defaultMessage) {
    return defaultMessage;
}